unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids;

type

  { THackStringGrid }

  THackStringGrid = class(TStringGrid)
  public
    procedure SelectEditor; override;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    procedure StringGrid1AfterSelection(Sender: TObject; aCol, aRow: Integer);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1SelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
  private
    FAllowEditing: Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ THackStringGrid }

procedure THackStringGrid.SelectEditor;
begin
  inherited SelectEditor;
end;

{ TForm1 }

procedure TForm1.StringGrid1SelectEditor(Sender: TObject; aCol, aRow: Integer;
  var Editor: TWinControl);
begin
  if not FAllowEditing then
    Editor := nil;
end;

procedure TForm1.StringGrid1AfterSelection(Sender: TObject; aCol, aRow: Integer);
begin
  FAllowEditing := False;
end;

procedure TForm1.StringGrid1DblClick(Sender: TObject);
begin
  FAllowEditing := True;
  THackStringGrid(StringGrid1).Selecteditor;
end;

end.

